//=============================================================================
// FUNCTION : OPENDRAWER()
//  PURPOSE : Open Cash Drawer when needed
//   CALLED : CfgEdit(), SaleNew(), WorkPkUp()
//    CALLS : CloseDrawer()
//   IMPORT : aApp
//            cPort   - Port the Drawer is Connected
//            nLen    - Length of string to send
//            lTest   - CfgEdit() ONLY for testing drawer
//   EXPORT : NONE
//   UPDATE :  4 NOV 2010
//=============================================================================

procedure OpenDrawer(aApp, cPort, nLen, lTest)

  local i, cLn := "", nHdl
  local aDrwGroup := { "PORT","LENGTH" }, aDrwData := { "    ", 0 }

  DCMSGBOX "OPEN DRAWER" TIMEOUT .8
  if valtype(cPort) # 'C'
    cPort := ""
  endif
  if valtype(nLen)  # 'N'
    nLen := 0
  endif
  if valtype(lTest) # 'L'
    lTest := .F.
  endif
  //
  if empty(cPort) .or. empty(nLen)
    if DC_IniLoad("DRAWER.INI", "DRAWER", @aDrwData, aDrwGroup)
      cPort := aDrwData[1]
      nLen  := aDrwData[2]
    else
      cPort := ""
      nLen  := 0
    endif
  endif
  //
  if empty(cPort)
    DCMSGBOX "Need the Port the Drawer is connected to!" TIMEOUT 4
  elseif empty(nLen)
    DCMSGBOX "Need the length of the open pulse!" TIMEOUT 4
  else
    nHdl  := fcreate(cPort, FO_READWRITE)
    if nHdl < 0
      return
    endif
    //-
    //-- Send Serial Port character string to open cash drawer
    //-
    for i := 1 to nLen
      cLn += 'A'
    next
    fwrite(nHdl, cLn)
    fclose(nHdl)
    tone(440,2)
    if lTest
      CloseDrawer(@aApp)
    endif
  endif
  return


